package board;

import java.awt.*;
import java.awt.event.ActionListener;

public class MyMenuBar extends MenuBar implements ActionListener
{
	MyMenuBar myMenuBar;
	MyMenuBar(){
		super();
		myMenuBar = this;

		Menu fileMenu = new java.awt.Menu("File");
		add(fileMenu);
		fileMenu.add(new MyMenuItem("shuffle"));
		fileMenu.add(new MyMenuItem("loadImage"));
		fileMenu.add(new MyMenuItem("exit"));
	}


	class MyMenuItem extends MenuItem {
		MyMenuItem(String label){
			super();
			setLabel(label);
			addActionListener(myMenuBar);
		}
	}
	
	public void actionPerformed(java.awt.event.ActionEvent event)
	{
		if (event.getSource() instanceof MyMenuItem){
			String label = ((MyMenuItem)event.getSource()).getLabel();
			if (label.equals("shuffle")){
				MainPanel.mainPanel.puzzle.shuffle();
				MainPanel.mainPanel.repaint();
			}
			else if (label.equals("loadImage")){
				String filename = get_filename();
				if (filename != null)
					MainPanel.mainPanel.puzzle.setImage(filename);
				MainPanel.mainPanel.repaint();
			}
			else if (label.equals("exit"))
				System.exit(0);

		}

	}
	String get_filename(){
		String filename = null;
		java.awt.FileDialog fileDialog = new java.awt.FileDialog( Main.f, "Load Image", java.awt.FileDialog.LOAD );
		fileDialog.setDirectory(".\\images\\");
		fileDialog.setVisible(true);
		filename =  fileDialog.getDirectory()+"\\"+fileDialog.getFile();
		fileDialog.dispose();		
		return filename;
	}

}
