package board;

import java.util.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import javax.swing.*;

public class Piece
{
	Puzzle puzzle;
	
	Point position = new Point(100, 100);
	//double scale = 1;
	double angle = 0;
	
	Image image;
	int width;
	int height;

	Piece(Puzzle puzzle, int x, int y, int wx, int wy){
		this.puzzle = puzzle;
		position = new Point(x, y);
		width = wx;
		height = wy;
		
		image = MainPanel.mainPanel.createImage(width, height);
	}
	
	void draw(Graphics g){
		Graphics2D g2 = (Graphics2D) g;
		
		AffineTransform af = new AffineTransform();
		af.translate(position.x, position.y);
		af.rotate(angle * Math.PI/180);
		//af.scale(scale, scale);
		af.translate(-width/2, -height/2);
		
		g2.drawImage(image, af, null);
		
	}

	public boolean picked(Point p){
		int xsize = (int) Math.abs(width * Math.cos(angle * Math.PI/180) + height * Math.sin(angle * Math.PI/180));
		int ysize = (int) Math.abs(width * Math.sin(angle * Math.PI/180) + height * Math.cos(angle * Math.PI/180));
		return ( Math.abs(p.x-position.x) < xsize/2 && Math.abs(p.y-position.y) < ysize/2);  
	}
	
	public void move_relative(int dx, int dy){
		position.x += dx;
		position.y += dy;
	}
	public void snap(){
		double step;
		step = 1.0* this.width / 10;
		position.x = (int)((int)(position.x / step + 0.5) * step);
		step = 1.0* this.height / 10;
		position.y = (int)((int)(position.y / step + 0.5) * step);
	}
	
	
	

	
	
	//
	// PopupMenȕ
	//
	static MyPopupMenu popupMenu= null;
	void show_popupmenu(int x, int y){
		if (popupMenu == null){
			popupMenu = new MyPopupMenu(MainPanel.mainPanel);
			popupMenu.addLabel("rotate_left");
			popupMenu.addLabel("rotate_right");
			popupMenu.addLabel("front");
			popupMenu.addLabel("back");
		}
		popupMenu.target = this;
		popupMenu.show(MainPanel.mainPanel, x, y);
	}
	void popupMenu_selected(String label){
		if (label.equals("rotate_left"))
			angle -= 90;
		else if (label.equals("rotate_right"))
			angle += 90;
		else if (label.equals("front")){
			front();
		}
		else if (label.equals("back")){
			back();
		}
		MainPanel.mainPanel.repaint();
	}
	void front(){
		puzzle.pieces.remove(this);
		puzzle.pieces.add(this);
	}
	void back(){
		puzzle.pieces.remove(this);
		puzzle.pieces.add(0,this);
	}

	
}
